/* DesktopHelper.c generated by valac 0.46.1, the Vala compiler
 * generated from DesktopHelper.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2015-2019 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include <glib-object.h>
#include <glib.h>
#include <gtk/gtk.h>
#include "plugin.h"
#include <gio/gio.h>
#include <libwnck/libwnck.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gdesktopappinfo.h>

#define TYPE_DESKTOP_HELPER (desktop_helper_get_type ())
#define DESKTOP_HELPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DESKTOP_HELPER, DesktopHelper))
#define DESKTOP_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DESKTOP_HELPER, DesktopHelperClass))
#define IS_DESKTOP_HELPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DESKTOP_HELPER))
#define IS_DESKTOP_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DESKTOP_HELPER))
#define DESKTOP_HELPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DESKTOP_HELPER, DesktopHelperClass))

typedef struct _DesktopHelper DesktopHelper;
typedef struct _DesktopHelperClass DesktopHelperClass;
typedef struct _DesktopHelperPrivate DesktopHelperPrivate;
enum  {
	DESKTOP_HELPER_0_PROPERTY,
	DESKTOP_HELPER_NUM_PROPERTIES
};
static GParamSpec* desktop_helper_properties[DESKTOP_HELPER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_ICON_BUTTON (icon_button_get_type ())
#define ICON_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ICON_BUTTON, IconButton))
#define ICON_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ICON_BUTTON, IconButtonClass))
#define IS_ICON_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ICON_BUTTON))
#define IS_ICON_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ICON_BUTTON))
#define ICON_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ICON_BUTTON, IconButtonClass))

typedef struct _IconButton IconButton;
typedef struct _IconButtonClass IconButtonClass;

#define TYPE_BUTTON_WRAPPER (button_wrapper_get_type ())
#define BUTTON_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BUTTON_WRAPPER, ButtonWrapper))
#define BUTTON_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BUTTON_WRAPPER, ButtonWrapperClass))
#define IS_BUTTON_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BUTTON_WRAPPER))
#define IS_BUTTON_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BUTTON_WRAPPER))
#define BUTTON_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BUTTON_WRAPPER, ButtonWrapperClass))

typedef struct _ButtonWrapper ButtonWrapper;
typedef struct _ButtonWrapperClass ButtonWrapperClass;
typedef struct _ButtonWrapperPrivate ButtonWrapperPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;

struct _DesktopHelper {
	GObject parent_instance;
	DesktopHelperPrivate * priv;
	gint panel_size;
	gint icon_size;
	GtkOrientation orientation;
	BudgiePanelPosition panel_position;
	gboolean lock_icons;
};

struct _DesktopHelperClass {
	GObjectClass parent_class;
};

struct _DesktopHelperPrivate {
	GSettings* settings;
	WnckScreen* screen;
	GtkBox* icon_layout;
};

struct _ButtonWrapper {
	GtkRevealer parent_instance;
	ButtonWrapperPrivate * priv;
	IconButton* button;
};

struct _ButtonWrapperClass {
	GtkRevealerClass parent_class;
};

struct _Block1Data {
	int _ref_count_;
	DesktopHelper* self;
	GList* list;
	WnckClassGroup* class_group;
};

static gint DesktopHelper_private_offset;
static gpointer desktop_helper_parent_class = NULL;
static GType desktop_helper_type_id = 0;

GType desktop_helper_register_type (GTypeModule * module);
GType desktop_helper_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopHelper, g_object_unref)
DesktopHelper* desktop_helper_new (GSettings* settings,
                                   GtkBox* icon_layout);
DesktopHelper* desktop_helper_construct (GType object_type,
                                         GSettings* settings,
                                         GtkBox* icon_layout);
void desktop_helper_update_pinned (DesktopHelper* self);
GType icon_button_register_type (GTypeModule * module);
GType icon_button_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IconButton, g_object_unref)
GType button_wrapper_register_type (GTypeModule * module);
GType button_wrapper_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ButtonWrapper, g_object_unref)
gboolean icon_button_is_pinned (IconButton* self);
GDesktopAppInfo* icon_button_get_appinfo (IconButton* self);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      int stack_length,
                                      const gchar* needle);
static void _vala_array_add1 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
GList* desktop_helper_get_stacked_for_classgroup (DesktopHelper* self,
                                                  WnckClassGroup* class_group);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda19_ (Block1Data* _data1_,
                  WnckWindow* window);
WnckWorkspace* desktop_helper_get_active_workspace (DesktopHelper* self);
static void ___lambda19__gfunc (gconstpointer data,
                         gpointer self);
WnckWindow* desktop_helper_get_active_window (DesktopHelper* self);
static void desktop_helper_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

const GtkTargetEntry DESKTOP_HELPER_targets[3] = {{"application/x-icon-tasklist-launcher-id", (guint) 0, (guint) 0}, {"text/uri-list", (guint) 0, (guint) 0}, {"application/x-desktop", (guint) 0, (guint) 0}};

static inline gpointer
desktop_helper_get_instance_private (DesktopHelper* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopHelper_private_offset);
}

/**
     * Handle initial bootstrap of the desktop helper
     */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

DesktopHelper*
desktop_helper_construct (GType object_type,
                          GSettings* settings,
                          GtkBox* icon_layout)
{
	DesktopHelper * self = NULL;
	GSettings* _tmp0_;
	GtkBox* _tmp1_;
	WnckScreen* _tmp2_;
	WnckScreen* _tmp3_;
	self = (DesktopHelper*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (settings);
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp0_;
	_tmp1_ = _g_object_ref0 (icon_layout);
	_g_object_unref0 (self->priv->icon_layout);
	self->priv->icon_layout = _tmp1_;
	_tmp2_ = wnck_screen_get_default ();
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->priv->screen);
	self->priv->screen = _tmp3_;
	return self;
}

DesktopHelper*
desktop_helper_new (GSettings* settings,
                    GtkBox* icon_layout)
{
	return desktop_helper_construct (TYPE_DESKTOP_HELPER, settings, icon_layout);
}

/**
     * Using our icon_layout, update the per-instance "pinned-launchers" key
     * Keeping with pinned internally for compatibility.
     */
static gboolean
_vala_string_array_contains (gchar* * stack,
                             int stack_length,
                             const gchar* needle)
{
	int i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}

static void
_vala_array_add1 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

void
desktop_helper_update_pinned (DesktopHelper* self)
{
	gchar** buttons = NULL;
	gchar** _tmp0_;
	gint buttons_length1;
	gint _buttons_size_;
	GtkBox* _tmp1_;
	GList* _tmp2_;
	GSettings* _tmp23_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	buttons = _tmp0_;
	buttons_length1 = 0;
	_buttons_size_ = buttons_length1;
	_tmp1_ = self->priv->icon_layout;
	_tmp2_ = gtk_container_get_children ((GtkContainer*) _tmp1_);
	{
		GList* widget_collection = NULL;
		GList* widget_it = NULL;
		widget_collection = _tmp2_;
		for (widget_it = widget_collection; widget_it != NULL; widget_it = widget_it->next) {
			GtkWidget* _tmp3_;
			GtkWidget* widget = NULL;
			_tmp3_ = _g_object_ref0 ((GtkWidget*) widget_it->data);
			widget = _tmp3_;
			{
				IconButton* button = NULL;
				GtkWidget* _tmp4_;
				IconButton* _tmp5_;
				IconButton* _tmp6_;
				IconButton* _tmp7_;
				IconButton* _tmp8_;
				GDesktopAppInfo* _tmp9_;
				GDesktopAppInfo* _tmp10_;
				gboolean _tmp11_;
				gchar* id = NULL;
				IconButton* _tmp12_;
				GDesktopAppInfo* _tmp13_;
				GDesktopAppInfo* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				const gchar* _tmp18_;
				gchar** _tmp19_;
				gint _tmp19__length1;
				gchar** _tmp20_;
				gint _tmp20__length1;
				const gchar* _tmp21_;
				gchar* _tmp22_;
				_tmp4_ = widget;
				_tmp5_ = (IS_BUTTON_WRAPPER (_tmp4_) ? ((ButtonWrapper*) _tmp4_) : NULL)->button;
				_tmp6_ = _g_object_ref0 (_tmp5_);
				button = _tmp6_;
				_tmp7_ = button;
				if (!icon_button_is_pinned (_tmp7_)) {
					_g_object_unref0 (button);
					_g_object_unref0 (widget);
					continue;
				}
				_tmp8_ = button;
				_tmp9_ = icon_button_get_appinfo (_tmp8_);
				_tmp10_ = _tmp9_;
				_tmp11_ = _tmp10_ == NULL;
				_g_object_unref0 (_tmp10_);
				if (_tmp11_) {
					_g_object_unref0 (button);
					_g_object_unref0 (widget);
					continue;
				}
				_tmp12_ = button;
				_tmp13_ = icon_button_get_appinfo (_tmp12_);
				_tmp14_ = _tmp13_;
				_tmp15_ = g_app_info_get_id ((GAppInfo*) _tmp14_);
				_tmp16_ = g_strdup (_tmp15_);
				_tmp17_ = _tmp16_;
				_g_object_unref0 (_tmp14_);
				id = _tmp17_;
				_tmp18_ = id;
				_tmp19_ = buttons;
				_tmp19__length1 = buttons_length1;
				if (_vala_string_array_contains (_tmp19_, _tmp19__length1, _tmp18_)) {
					_g_free0 (id);
					_g_object_unref0 (button);
					_g_object_unref0 (widget);
					continue;
				}
				_tmp20_ = buttons;
				_tmp20__length1 = buttons_length1;
				_tmp21_ = id;
				_tmp22_ = g_strdup (_tmp21_);
				_vala_array_add1 (&buttons, &buttons_length1, &_buttons_size_, _tmp22_);
				_g_free0 (id);
				_g_object_unref0 (button);
				_g_object_unref0 (widget);
			}
		}
		(widget_collection == NULL) ? NULL : (widget_collection = (g_list_free (widget_collection), NULL));
	}
	_tmp23_ = self->priv->settings;
	_tmp24_ = buttons;
	_tmp24__length1 = buttons_length1;
	g_settings_set_strv (_tmp23_, "pinned-launchers", _tmp24_);
	buttons = (_vala_array_free (buttons, buttons_length1, (GDestroyNotify) g_free), NULL);
}

/**
     * Grab the list of windows stacked for the given class_group
     */
static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		DesktopHelper* self;
		self = _data1_->self;
		(_data1_->list == NULL) ? NULL : (_data1_->list = (g_list_free (_data1_->list), NULL));
		_g_object_unref0 (_data1_->class_group);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static void
__lambda19_ (Block1Data* _data1_,
             WnckWindow* window)
{
	DesktopHelper* self;
	gboolean _tmp0_ = FALSE;
	WnckClassGroup* _tmp1_;
	self = _data1_->self;
	g_return_if_fail (window != NULL);
	_tmp1_ = wnck_window_get_class_group (window);
	if (_tmp1_ == _data1_->class_group) {
		_tmp0_ = !wnck_window_is_skip_tasklist (window);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		WnckWorkspace* workspace = NULL;
		WnckWorkspace* _tmp2_;
		WnckWorkspace* _tmp3_;
		WnckWorkspace* _tmp4_;
		WnckWorkspace* _tmp5_;
		WnckWorkspace* _tmp6_;
		WnckWorkspace* _tmp7_;
		gboolean _tmp8_;
		_tmp2_ = wnck_window_get_workspace (window);
		_tmp3_ = _g_object_ref0 (_tmp2_);
		workspace = _tmp3_;
		_tmp4_ = workspace;
		if (_tmp4_ == NULL) {
			_g_object_unref0 (workspace);
			return;
		}
		_tmp5_ = workspace;
		_tmp6_ = desktop_helper_get_active_workspace (self);
		_tmp7_ = _tmp6_;
		_tmp8_ = _tmp5_ == _tmp7_;
		_g_object_unref0 (_tmp7_);
		if (_tmp8_) {
			_data1_->list = g_list_append (_data1_->list, window);
		}
		_g_object_unref0 (workspace);
	}
}

static void
___lambda19__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda19_ (self, (WnckWindow*) data);
}

GList*
desktop_helper_get_stacked_for_classgroup (DesktopHelper* self,
                                           WnckClassGroup* class_group)
{
	Block1Data* _data1_;
	WnckClassGroup* _tmp0_;
	WnckScreen* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	GList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (class_group != NULL, NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (class_group);
	_g_object_unref0 (_data1_->class_group);
	_data1_->class_group = _tmp0_;
	_data1_->list = NULL;
	_tmp1_ = self->priv->screen;
	_tmp2_ = wnck_screen_get_windows_stacked (_tmp1_);
	g_list_foreach (_tmp2_, ___lambda19__gfunc, _data1_);
	_tmp3_ = g_list_copy (_data1_->list);
	result = _tmp3_;
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return result;
}

/**
     * Return the currently active window
     */
WnckWindow*
desktop_helper_get_active_window (DesktopHelper* self)
{
	WnckScreen* _tmp0_;
	WnckWindow* _tmp1_;
	WnckWindow* _tmp2_;
	WnckWindow* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->screen;
	_tmp1_ = wnck_screen_get_active_window (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	result = _tmp2_;
	return result;
}

/**
     * Return the currently active workspace
     */
WnckWorkspace*
desktop_helper_get_active_workspace (DesktopHelper* self)
{
	WnckScreen* _tmp0_;
	WnckWorkspace* _tmp1_;
	WnckWorkspace* _tmp2_;
	WnckWorkspace* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->screen;
	_tmp1_ = wnck_screen_get_active_workspace (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	result = _tmp2_;
	return result;
}

static void
desktop_helper_class_init (DesktopHelperClass * klass,
                           gpointer klass_data)
{
	desktop_helper_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DesktopHelper_private_offset);
	G_OBJECT_CLASS (klass)->finalize = desktop_helper_finalize;
}

static void
desktop_helper_instance_init (DesktopHelper * self,
                              gpointer klass)
{
	self->priv = desktop_helper_get_instance_private (self);
	self->priv->settings = NULL;
	self->priv->screen = NULL;
	self->priv->icon_layout = NULL;
	self->panel_size = 40;
	self->icon_size = 32;
	self->orientation = GTK_ORIENTATION_HORIZONTAL;
	self->panel_position = BUDGIE_PANEL_POSITION_BOTTOM;
	self->lock_icons = FALSE;
}

static void
desktop_helper_finalize (GObject * obj)
{
	DesktopHelper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DESKTOP_HELPER, DesktopHelper);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->screen);
	_g_object_unref0 (self->priv->icon_layout);
	G_OBJECT_CLASS (desktop_helper_parent_class)->finalize (obj);
}

/**
 * Trivial helper for IconTasklist - i.e. desktop lookups
 */
GType
desktop_helper_get_type (void)
{
	return desktop_helper_type_id;
}

GType
desktop_helper_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopHelperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_helper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopHelper), 0, (GInstanceInitFunc) desktop_helper_instance_init, NULL };
	desktop_helper_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "DesktopHelper", &g_define_type_info, 0);
	DesktopHelper_private_offset = sizeof (DesktopHelperPrivate);
	return desktop_helper_type_id;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

