/* animation.c generated by valac 0.46.1, the Vala compiler
 * generated from animation.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2015-2019 Budgie Desktop Developers
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
/**<Target value for end of animation */

#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

typedef gdouble (*BudgieTaskListTweenFunc) (gdouble factor, gpointer user_data);

#define BUDGIE_TASK_LIST_TYPE_ANIMATION (budgie_task_list_animation_get_type ())
#define BUDGIE_TASK_LIST_ANIMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BUDGIE_TASK_LIST_TYPE_ANIMATION, BudgieTaskListAnimation))
#define BUDGIE_TASK_LIST_ANIMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BUDGIE_TASK_LIST_TYPE_ANIMATION, BudgieTaskListAnimationClass))
#define BUDGIE_TASK_LIST_IS_ANIMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BUDGIE_TASK_LIST_TYPE_ANIMATION))
#define BUDGIE_TASK_LIST_IS_ANIMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BUDGIE_TASK_LIST_TYPE_ANIMATION))
#define BUDGIE_TASK_LIST_ANIMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BUDGIE_TASK_LIST_TYPE_ANIMATION, BudgieTaskListAnimationClass))

typedef struct _BudgieTaskListAnimation BudgieTaskListAnimation;
typedef struct _BudgieTaskListAnimationClass BudgieTaskListAnimationClass;
typedef void (*BudgieTaskListAnimCompletionFunc) (BudgieTaskListAnimation* src, gpointer user_data);

#define BUDGIE_TASK_LIST_TYPE_PROP_CHANGE (budgie_task_list_prop_change_get_type ())
typedef struct _BudgieTaskListPropChange BudgieTaskListPropChange;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _BudgieTaskListAnimationPrivate BudgieTaskListAnimationPrivate;
enum  {
	BUDGIE_TASK_LIST_ANIMATION_0_PROPERTY,
	BUDGIE_TASK_LIST_ANIMATION_NUM_PROPERTIES
};
static GParamSpec* budgie_task_list_animation_properties[BUDGIE_TASK_LIST_ANIMATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _BudgieTaskListPropChange {
	gchar* property;
	GValue old;
	GValue new;
};

struct _BudgieTaskListAnimation {
	GObject parent_instance;
	BudgieTaskListAnimationPrivate * priv;
	gint64 start_time;
	gint64 length;
	BudgieTaskListTweenFunc tween;
	gpointer tween_target;
	BudgieTaskListPropChange* changes;
	gint changes_length1;
	GtkWidget* widget;
	GObject* object;
	guint id;
	gboolean can_anim;
	gint64 elapsed;
	gboolean no_reset;
};

struct _BudgieTaskListAnimationClass {
	GObjectClass parent_class;
};

struct _BudgieTaskListAnimationPrivate {
	BudgieTaskListAnimCompletionFunc compl;
	gpointer compl_target;
	GDestroyNotify compl_target_destroy_notify;
};

static gint BudgieTaskListAnimation_private_offset;
static gpointer budgie_task_list_animation_parent_class = NULL;
static GType budgie_task_list_animation_type_id = 0;

GType budgie_task_list_animation_register_type (GTypeModule * module);
GType budgie_task_list_animation_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BudgieTaskListAnimation, g_object_unref)
GType budgie_task_list_prop_change_get_type (void) G_GNUC_CONST;
BudgieTaskListPropChange* budgie_task_list_prop_change_dup (const BudgieTaskListPropChange* self);
void budgie_task_list_prop_change_free (BudgieTaskListPropChange* self);
void budgie_task_list_prop_change_copy (const BudgieTaskListPropChange* self,
                                        BudgieTaskListPropChange* dest);
void budgie_task_list_prop_change_destroy (BudgieTaskListPropChange* self);
static void _vala_BudgieTaskListPropChange_array_free (BudgieTaskListPropChange * array,
                                                gint array_length);
static gboolean budgie_task_list_animation_tick_callback (BudgieTaskListAnimation* self,
                                                   GtkWidget* widget,
                                                   GdkFrameClock* frame);
void budgie_task_list_animation_start (BudgieTaskListAnimation* self,
                                       BudgieTaskListAnimCompletionFunc compl,
                                       gpointer compl_target);
static gboolean _budgie_task_list_animation_tick_callback_gtk_tick_callback (GtkWidget* widget,
                                                                      GdkFrameClock* frame_clock,
                                                                      gpointer self);
void budgie_task_list_animation_stop (BudgieTaskListAnimation* self);
BudgieTaskListAnimation* budgie_task_list_animation_new (void);
BudgieTaskListAnimation* budgie_task_list_animation_construct (GType object_type);
static void budgie_task_list_animation_finalize (GObject * obj);
gdouble budgie_task_list_sine_ease_in_out (gdouble p);
gdouble budgie_task_list_sine_ease_in (gdouble p);
gdouble budgie_task_list_sine_ease_out (gdouble p);
gdouble budgie_task_list_elastic_ease_in (gdouble p);
gdouble budgie_task_list_elastic_ease_out (gdouble p);
gdouble budgie_task_list_back_ease_in (gdouble p);
gdouble budgie_task_list_back_ease_out (gdouble p);
gdouble budgie_task_list_expo_ease_in (gdouble p);
gdouble budgie_task_list_expo_ease_out (gdouble p);
gdouble budgie_task_list_quad_ease_in (gdouble p);
gdouble budgie_task_list_quad_ease_out (gdouble p);
gdouble budgie_task_list_quad_ease_in_out (gdouble p);
gdouble budgie_task_list_circ_ease_in (gdouble p);
gdouble budgie_task_list_circ_ease_out (gdouble p);
#define BUDGIE_TASK_LIST_MSECOND ((gint64) 1000)

void
budgie_task_list_prop_change_copy (const BudgieTaskListPropChange* self,
                                   BudgieTaskListPropChange* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GValue _tmp2_;
	GValue _tmp3_;
	GValue _tmp4_ = {0};
	GValue _tmp5_;
	GValue _tmp6_;
	GValue _tmp7_ = {0};
	_tmp0_ = (*self).property;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).property);
	(*dest).property = _tmp1_;
	_tmp2_ = (*self).old;
	_tmp3_ = _tmp2_;
	if (G_IS_VALUE (&_tmp3_)) {
		g_value_init (&_tmp4_, G_VALUE_TYPE (&_tmp3_));
		g_value_copy (&_tmp3_, &_tmp4_);
	} else {
		_tmp4_ = _tmp3_;
	}
	G_IS_VALUE (&(*dest).old) ? (g_value_unset (&(*dest).old), NULL) : NULL;
	(*dest).old = _tmp4_;
	_tmp5_ = (*self).new;
	_tmp6_ = _tmp5_;
	if (G_IS_VALUE (&_tmp6_)) {
		g_value_init (&_tmp7_, G_VALUE_TYPE (&_tmp6_));
		g_value_copy (&_tmp6_, &_tmp7_);
	} else {
		_tmp7_ = _tmp6_;
	}
	G_IS_VALUE (&(*dest).new) ? (g_value_unset (&(*dest).new), NULL) : NULL;
	(*dest).new = _tmp7_;
}

void
budgie_task_list_prop_change_destroy (BudgieTaskListPropChange* self)
{
	_g_free0 ((*self).property);
	G_IS_VALUE (&(*self).old) ? (g_value_unset (&(*self).old), NULL) : NULL;
	G_IS_VALUE (&(*self).new) ? (g_value_unset (&(*self).new), NULL) : NULL;
}

BudgieTaskListPropChange*
budgie_task_list_prop_change_dup (const BudgieTaskListPropChange* self)
{
	BudgieTaskListPropChange* dup;
	dup = g_new0 (BudgieTaskListPropChange, 1);
	budgie_task_list_prop_change_copy (self, dup);
	return dup;
}

void
budgie_task_list_prop_change_free (BudgieTaskListPropChange* self)
{
	budgie_task_list_prop_change_destroy (self);
	g_free (self);
}

GType
budgie_task_list_prop_change_get_type (void)
{
	static volatile gsize budgie_task_list_prop_change_type_id__volatile = 0;
	if (g_once_init_enter (&budgie_task_list_prop_change_type_id__volatile)) {
		GType budgie_task_list_prop_change_type_id;
		budgie_task_list_prop_change_type_id = g_boxed_type_register_static ("BudgieTaskListPropChange", (GBoxedCopyFunc) budgie_task_list_prop_change_dup, (GBoxedFreeFunc) budgie_task_list_prop_change_free);
		g_once_init_leave (&budgie_task_list_prop_change_type_id__volatile, budgie_task_list_prop_change_type_id);
	}
	return budgie_task_list_prop_change_type_id__volatile;
}

static inline gpointer
budgie_task_list_animation_get_instance_private (BudgieTaskListAnimation* self)
{
	return G_STRUCT_MEMBER_P (self, BudgieTaskListAnimation_private_offset);
}

static void
_vala_BudgieTaskListPropChange_array_free (BudgieTaskListPropChange * array,
                                           gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			budgie_task_list_prop_change_destroy (&array[i]);
		}
	}
	g_free (array);
}

static gboolean
budgie_task_list_animation_tick_callback (BudgieTaskListAnimation* self,
                                          GtkWidget* widget,
                                          GdkFrameClock* frame)
{
	gint64 time = 0LL;
	gfloat factor = 0.0F;
	gint64 elapsed = 0LL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	BudgieTaskListPropChange* _tmp17_;
	gint _tmp17__length1;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (frame != NULL, FALSE);
	time = gdk_frame_clock_get_frame_time (frame);
	factor = 0.0f;
	elapsed = time - self->start_time;
	if (elapsed >= self->length) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = self->id == ((guint) 0);
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = !self->can_anim;
	}
	if (_tmp0_) {
		if (self->id > ((guint) 0)) {
			BudgieTaskListPropChange* _tmp2_;
			gint _tmp2__length1;
			_tmp2_ = self->changes;
			_tmp2__length1 = self->changes_length1;
			{
				BudgieTaskListPropChange* p_collection = NULL;
				gint p_collection_length1 = 0;
				gint _p_collection_size_ = 0;
				gint p_it = 0;
				p_collection = _tmp2_;
				p_collection_length1 = _tmp2__length1;
				for (p_it = 0; p_it < p_collection_length1; p_it = p_it + 1) {
					BudgieTaskListPropChange _tmp3_;
					BudgieTaskListPropChange _tmp4_ = {0};
					BudgieTaskListPropChange p = {0};
					_tmp3_ = p_collection[p_it];
					budgie_task_list_prop_change_copy (&_tmp3_, &_tmp4_);
					p = _tmp4_;
					{
						GObject* _tmp5_;
						_tmp5_ = self->object;
						if (_tmp5_ == NULL) {
							BudgieTaskListPropChange _tmp6_;
							const gchar* _tmp7_;
							BudgieTaskListPropChange _tmp8_;
							GValue _tmp9_;
							_tmp6_ = p;
							_tmp7_ = _tmp6_.property;
							_tmp8_ = p;
							_tmp9_ = _tmp8_.new;
							g_object_set_property ((GObject*) widget, _tmp7_, &_tmp9_);
						} else {
							GObject* _tmp10_;
							BudgieTaskListPropChange _tmp11_;
							const gchar* _tmp12_;
							BudgieTaskListPropChange _tmp13_;
							GValue _tmp14_;
							_tmp10_ = self->object;
							_tmp11_ = p;
							_tmp12_ = _tmp11_.property;
							_tmp13_ = p;
							_tmp14_ = _tmp13_.new;
							g_object_set_property (_tmp10_, _tmp12_, &_tmp14_);
						}
						budgie_task_list_prop_change_destroy (&p);
					}
				}
			}
		}
		self->id = (guint) 0;
		if (self->can_anim) {
			BudgieTaskListAnimCompletionFunc _tmp15_;
			gpointer _tmp15__target;
			self->can_anim = FALSE;
			_tmp15_ = self->priv->compl;
			_tmp15__target = self->priv->compl_target;
			if (_tmp15_ != NULL) {
				BudgieTaskListAnimCompletionFunc _tmp16_;
				gpointer _tmp16__target;
				_tmp16_ = self->priv->compl;
				_tmp16__target = self->priv->compl_target;
				_tmp16_ (self, _tmp16__target);
			}
		}
		gtk_widget_queue_draw (widget);
		result = FALSE;
		return result;
	}
	factor = CLAMP (((gfloat) elapsed) / self->length, (gfloat) 0, 1.0f);
	_tmp17_ = self->changes;
	_tmp17__length1 = self->changes_length1;
	{
		BudgieTaskListPropChange* c_collection = NULL;
		gint c_collection_length1 = 0;
		gint _c_collection_size_ = 0;
		gint c_it = 0;
		c_collection = _tmp17_;
		c_collection_length1 = _tmp17__length1;
		for (c_it = 0; c_it < c_collection_length1; c_it = c_it + 1) {
			BudgieTaskListPropChange _tmp18_;
			BudgieTaskListPropChange _tmp19_ = {0};
			BudgieTaskListPropChange c = {0};
			_tmp18_ = c_collection[c_it];
			budgie_task_list_prop_change_copy (&_tmp18_, &_tmp19_);
			c = _tmp19_;
			{
				gdouble old = 0.0;
				gdouble new = 0.0;
				BudgieTaskListTweenFunc _tmp20_;
				gpointer _tmp20__target;
				gdouble delta = 0.0;
				gdouble nprop = 0.0;
				GObject* _tmp22_;
				old = g_value_get_double (&c.old);
				new = g_value_get_double (&c.new);
				_tmp20_ = self->tween;
				_tmp20__target = self->tween_target;
				if (_tmp20_ != NULL) {
					BudgieTaskListTweenFunc _tmp21_;
					gpointer _tmp21__target;
					_tmp21_ = self->tween;
					_tmp21__target = self->tween_target;
					factor = (gfloat) _tmp21_ ((gdouble) factor, _tmp21__target);
				}
				delta = (new - old) * factor;
				nprop = (gdouble) (old + delta);
				_tmp22_ = self->object;
				if (_tmp22_ == NULL) {
					BudgieTaskListPropChange _tmp23_;
					const gchar* _tmp24_;
					GValue _tmp25_ = {0};
					_tmp23_ = c;
					_tmp24_ = _tmp23_.property;
					g_value_init (&_tmp25_, G_TYPE_DOUBLE);
					g_value_set_double (&_tmp25_, nprop);
					g_object_set_property ((GObject*) widget, _tmp24_, &_tmp25_);
					G_IS_VALUE (&_tmp25_) ? (g_value_unset (&_tmp25_), NULL) : NULL;
				} else {
					GObject* _tmp26_;
					BudgieTaskListPropChange _tmp27_;
					const gchar* _tmp28_;
					GValue _tmp29_ = {0};
					_tmp26_ = self->object;
					_tmp27_ = c;
					_tmp28_ = _tmp27_.property;
					g_value_init (&_tmp29_, G_TYPE_DOUBLE);
					g_value_set_double (&_tmp29_, nprop);
					g_object_set_property (_tmp26_, _tmp28_, &_tmp29_);
					G_IS_VALUE (&_tmp29_) ? (g_value_unset (&_tmp29_), NULL) : NULL;
				}
				budgie_task_list_prop_change_destroy (&c);
			}
		}
	}
	gtk_widget_queue_draw (widget);
	result = self->can_anim;
	return result;
}

/**
     * Start this animation by attaching ourselves to the GdkFrameClock
     *
     * @param compl A completion callback to execute when this animation completes
     */
static gboolean
_budgie_task_list_animation_tick_callback_gtk_tick_callback (GtkWidget* widget,
                                                             GdkFrameClock* frame_clock,
                                                             gpointer self)
{
	gboolean result;
	result = budgie_task_list_animation_tick_callback ((BudgieTaskListAnimation*) self, widget, frame_clock);
	return result;
}

void
budgie_task_list_animation_start (BudgieTaskListAnimation* self,
                                  BudgieTaskListAnimCompletionFunc compl,
                                  gpointer compl_target)
{
	GtkWidget* _tmp2_;
	g_return_if_fail (self != NULL);
	if (!self->no_reset) {
		GtkWidget* _tmp0_;
		GdkFrameClock* _tmp1_;
		_tmp0_ = self->widget;
		_tmp1_ = gtk_widget_get_frame_clock (_tmp0_);
		self->start_time = gdk_frame_clock_get_frame_time (_tmp1_);
	}
	(self->priv->compl_target_destroy_notify == NULL) ? NULL : (self->priv->compl_target_destroy_notify (self->priv->compl_target), NULL);
	self->priv->compl = NULL;
	self->priv->compl_target = NULL;
	self->priv->compl_target_destroy_notify = NULL;
	self->priv->compl = compl;
	self->priv->compl_target = compl_target;
	self->priv->compl_target_destroy_notify = NULL;
	self->can_anim = TRUE;
	_tmp2_ = self->widget;
	self->id = gtk_widget_add_tick_callback (_tmp2_, _budgie_task_list_animation_tick_callback_gtk_tick_callback, g_object_ref (self), g_object_unref);
}

/**
     * Stop a running animation
     */
void
budgie_task_list_animation_stop (BudgieTaskListAnimation* self)
{
	g_return_if_fail (self != NULL);
	self->can_anim = FALSE;
	if (self->id != ((guint) 0)) {
		GtkWidget* _tmp0_;
		_tmp0_ = self->widget;
		gtk_widget_remove_tick_callback (_tmp0_, self->id);
	}
	self->id = (guint) 0;
}

BudgieTaskListAnimation*
budgie_task_list_animation_construct (GType object_type)
{
	BudgieTaskListAnimation * self = NULL;
	self = (BudgieTaskListAnimation*) g_object_new (object_type, NULL);
	return self;
}

BudgieTaskListAnimation*
budgie_task_list_animation_new (void)
{
	return budgie_task_list_animation_construct (BUDGIE_TASK_LIST_TYPE_ANIMATION);
}

static void
budgie_task_list_animation_class_init (BudgieTaskListAnimationClass * klass,
                                       gpointer klass_data)
{
	budgie_task_list_animation_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &BudgieTaskListAnimation_private_offset);
	G_OBJECT_CLASS (klass)->finalize = budgie_task_list_animation_finalize;
}

static void
budgie_task_list_animation_instance_init (BudgieTaskListAnimation * self,
                                          gpointer klass)
{
	self->priv = budgie_task_list_animation_get_instance_private (self);
}

static void
budgie_task_list_animation_finalize (GObject * obj)
{
	BudgieTaskListAnimation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TASK_LIST_TYPE_ANIMATION, BudgieTaskListAnimation);
	self->changes = (_vala_BudgieTaskListPropChange_array_free (self->changes, self->changes_length1), NULL);
	_g_object_unref0 (self->object);
	(self->priv->compl_target_destroy_notify == NULL) ? NULL : (self->priv->compl_target_destroy_notify (self->priv->compl_target), NULL);
	self->priv->compl = NULL;
	self->priv->compl_target = NULL;
	self->priv->compl_target_destroy_notify = NULL;
	G_OBJECT_CLASS (budgie_task_list_animation_parent_class)->finalize (obj);
}

/**
 * Utility to struct to enable easier animations
 * Inspired by Clutter. 
 */
GType
budgie_task_list_animation_get_type (void)
{
	return budgie_task_list_animation_type_id;
}

GType
budgie_task_list_animation_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieTaskListAnimationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_task_list_animation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieTaskListAnimation), 0, (GInstanceInitFunc) budgie_task_list_animation_instance_init, NULL };
	budgie_task_list_animation_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "BudgieTaskListAnimation", &g_define_type_info, 0);
	BudgieTaskListAnimation_private_offset = sizeof (BudgieTaskListAnimationPrivate);
	return budgie_task_list_animation_type_id;
}

gdouble
budgie_task_list_sine_ease_in_out (gdouble p)
{
	gdouble result = 0.0;
	result = 0.5 * (1 - cos (p * G_PI));
	return result;
}

gdouble
budgie_task_list_sine_ease_in (gdouble p)
{
	gdouble result = 0.0;
	result = sin ((p - 1) * G_PI_2) + 1;
	return result;
}

gdouble
budgie_task_list_sine_ease_out (gdouble p)
{
	gdouble result = 0.0;
	result = sin (p * G_PI_2);
	return result;
}

gdouble
budgie_task_list_elastic_ease_in (gdouble p)
{
	gdouble result = 0.0;
	result = sin ((13 * G_PI_2) * p) * pow ((gdouble) 2, 10 * (p - 1));
	return result;
}

gdouble
budgie_task_list_elastic_ease_out (gdouble p)
{
	gdouble result = 0.0;
	result = (sin ((-13 * G_PI_2) * (p + 1)) * pow ((gdouble) 2, -10 * p)) + 1;
	return result;
}

gdouble
budgie_task_list_back_ease_in (gdouble p)
{
	gdouble result = 0.0;
	result = ((p * p) * p) - (p * sin (p * G_PI));
	return result;
}

gdouble
budgie_task_list_back_ease_out (gdouble p)
{
	gdouble f = 0.0;
	gdouble result = 0.0;
	f = 1 - p;
	result = 1 - (((f * f) * f) - (f * sin (f * G_PI)));
	return result;
}

gdouble
budgie_task_list_expo_ease_in (gdouble p)
{
	gdouble _tmp0_ = 0.0;
	gdouble result = 0.0;
	if (p == 0.0) {
		_tmp0_ = p;
	} else {
		_tmp0_ = pow ((gdouble) 2, 10 * (p - 1));
	}
	result = _tmp0_;
	return result;
}

gdouble
budgie_task_list_expo_ease_out (gdouble p)
{
	gdouble _tmp0_ = 0.0;
	gdouble result = 0.0;
	if (p == 1.0) {
		_tmp0_ = p;
	} else {
		_tmp0_ = 1 - pow ((gdouble) 2, -10 * p);
	}
	result = _tmp0_;
	return result;
}

gdouble
budgie_task_list_quad_ease_in (gdouble p)
{
	gdouble result = 0.0;
	result = p * p;
	return result;
}

gdouble
budgie_task_list_quad_ease_out (gdouble p)
{
	gdouble result = 0.0;
	result = -(p * (p - 2));
	return result;
}

gdouble
budgie_task_list_quad_ease_in_out (gdouble p)
{
	gdouble _tmp0_ = 0.0;
	gdouble result = 0.0;
	if (p < 0.5) {
		_tmp0_ = (2 * p) * p;
	} else {
		_tmp0_ = (((-2 * p) * p) + (4 * p)) - 1;
	}
	result = _tmp0_;
	return result;
}

gdouble
budgie_task_list_circ_ease_in (gdouble p)
{
	gdouble result = 0.0;
	result = 1 - sqrt (1 - (p * p));
	return result;
}

gdouble
budgie_task_list_circ_ease_out (gdouble p)
{
	gdouble result = 0.0;
	result = sqrt ((2 - p) * p);
	return result;
}

