/* SoundIndicator.c generated by valac 0.46.1, the Vala compiler
 * generated from SoundIndicator.vala, do not modify */

/*
 * This file is part of budgie-desktop
 * 
 * Copyright © 2015-2019 Budgie Desktop Developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include "plugin.h"
#include <pulse/pulseaudio.h>
#include <gvc-mixer-control.h>
#include <gvc-mixer-stream.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <gio/gdesktopappinfo.h>
#include <gio/gio.h>

#define TYPE_SOUND_INDICATOR (sound_indicator_get_type ())
#define SOUND_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOUND_INDICATOR, SoundIndicator))
#define SOUND_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOUND_INDICATOR, SoundIndicatorClass))
#define IS_SOUND_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOUND_INDICATOR))
#define IS_SOUND_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOUND_INDICATOR))
#define SOUND_INDICATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOUND_INDICATOR, SoundIndicatorClass))

typedef struct _SoundIndicator SoundIndicator;
typedef struct _SoundIndicatorClass SoundIndicatorClass;
typedef struct _SoundIndicatorPrivate SoundIndicatorPrivate;
enum  {
	SOUND_INDICATOR_0_PROPERTY,
	SOUND_INDICATOR_WIDGET_PROPERTY,
	SOUND_INDICATOR_MIXER_PROPERTY,
	SOUND_INDICATOR_NUM_PROPERTIES
};
static GParamSpec* sound_indicator_properties[SOUND_INDICATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _SoundIndicator {
	GtkBin parent_instance;
	SoundIndicatorPrivate * priv;
	guint32 unmuted_volume_val;
	GtkEventBox* ebox;
	BudgiePopover* popover;
};

struct _SoundIndicatorClass {
	GtkBinClass parent_class;
};

struct _SoundIndicatorPrivate {
	GtkImage* _widget;
	GvcMixerControl* _mixer;
	GvcMixerStream* stream;
	GtkScale* volume_scale;
	gdouble step_size;
	gulong notify_id;
	gulong scale_id;
};

static gint SoundIndicator_private_offset;
static gpointer sound_indicator_parent_class = NULL;
static GType sound_indicator_type_id = 0;

#define MIXER_NAME "Budgie Volume Control"
GType sound_indicator_register_type (GTypeModule * module);
GType sound_indicator_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SoundIndicator, g_object_unref)
SoundIndicator* sound_indicator_new (void);
SoundIndicator* sound_indicator_construct (GType object_type);
void sound_indicator_set_widget (SoundIndicator* self,
                                 GtkImage* value);
GtkImage* sound_indicator_get_widget (SoundIndicator* self);
void sound_indicator_set_mixer (SoundIndicator* self,
                                GvcMixerControl* value);
GvcMixerControl* sound_indicator_get_mixer (SoundIndicator* self);
void sound_indicator_on_state_change (SoundIndicator* self,
                                      guint new_state);
static void _sound_indicator_on_state_change_gvc_mixer_control_state_changed (GvcMixerControl* _sender,
                                                                       guint new_state,
                                                                       gpointer self);
static void sound_indicator_on_sink_changed (SoundIndicator* self,
                                      guint id);
static void _sound_indicator_on_sink_changed_gvc_mixer_control_default_sink_changed (GvcMixerControl* _sender,
                                                                              guint id,
                                                                              gpointer self);
static void sound_indicator_create_sound_popover (SoundIndicator* self);
gboolean sound_indicator_on_scroll_event (SoundIndicator* self,
                                          GdkEventScroll* event);
static gboolean _sound_indicator_on_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                   GdkEventScroll* event,
                                                                   gpointer self);
static gboolean sound_indicator_on_button_release_event (SoundIndicator* self,
                                                  GdkEventButton* e);
static gboolean _sound_indicator_on_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                   GdkEventButton* event,
                                                                                   gpointer self);
static void __lambda8_ (SoundIndicator* self);
static void sound_indicator_adjust_volume_increment (SoundIndicator* self,
                                              gdouble increment);
static void ___lambda8__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void sound_indicator_on_scale_changed (SoundIndicator* self);
static void _sound_indicator_on_scale_changed_gtk_range_value_changed (GtkRange* _sender,
                                                                gpointer self);
static void __lambda9_ (SoundIndicator* self);
static void ___lambda9__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void sound_indicator_open_sound_settings (SoundIndicator* self);
static void _sound_indicator_open_sound_settings_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void sound_indicator_set_default_mixer (SoundIndicator* self);
static void sound_indicator_on_notify (SoundIndicator* self,
                                GObject* o,
                                GParamSpec* p);
static void _sound_indicator_on_notify_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self);
void sound_indicator_update_volume (SoundIndicator* self);
static void sound_indicator_finalize (GObject * obj);
static void _vala_sound_indicator_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_sound_indicator_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
sound_indicator_get_instance_private (SoundIndicator* self)
{
	return G_STRUCT_MEMBER_P (self, SoundIndicator_private_offset);
}

static void
_sound_indicator_on_state_change_gvc_mixer_control_state_changed (GvcMixerControl* _sender,
                                                                  guint new_state,
                                                                  gpointer self)
{
	sound_indicator_on_state_change ((SoundIndicator*) self, new_state);
}

static void
_sound_indicator_on_sink_changed_gvc_mixer_control_default_sink_changed (GvcMixerControl* _sender,
                                                                         guint id,
                                                                         gpointer self)
{
	sound_indicator_on_sink_changed ((SoundIndicator*) self, id);
}

static gboolean
_sound_indicator_on_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender,
                                                          GdkEventScroll* event,
                                                          gpointer self)
{
	gboolean result;
	result = sound_indicator_on_scroll_event ((SoundIndicator*) self, event);
	return result;
}

static gboolean
_sound_indicator_on_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                          GdkEventButton* event,
                                                                          gpointer self)
{
	gboolean result;
	result = sound_indicator_on_button_release_event ((SoundIndicator*) self, event);
	return result;
}

SoundIndicator*
sound_indicator_construct (GType object_type)
{
	SoundIndicator * self = NULL;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkEventBox* _tmp2_;
	GtkEventBox* _tmp3_;
	GtkImage* _tmp4_;
	GtkEventBox* _tmp5_;
	GtkEventBox* _tmp6_;
	GtkEventBox* _tmp7_;
	GvcMixerControl* _tmp8_;
	GvcMixerControl* _tmp9_;
	GvcMixerControl* _tmp10_;
	GvcMixerControl* _tmp11_;
	GvcMixerControl* _tmp12_;
	GtkStyleContext* _tmp13_;
	BudgiePopover* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkEventBox* _tmp16_;
	GtkEventBox* _tmp17_;
	GtkEventBox* _tmp18_;
	GtkEventBox* _tmp19_;
	self = (SoundIndicator*) g_object_new (object_type, NULL);
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("audio-volume-muted-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp0_);
	_tmp1_ = _tmp0_;
	sound_indicator_set_widget (self, _tmp1_);
	_g_object_unref0 (_tmp1_);
	_tmp2_ = (GtkEventBox*) gtk_event_box_new ();
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->ebox);
	self->ebox = _tmp2_;
	_tmp3_ = self->ebox;
	_tmp4_ = self->priv->_widget;
	gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
	_tmp5_ = self->ebox;
	g_object_set ((GtkWidget*) _tmp5_, "margin", 0, NULL);
	_tmp6_ = self->ebox;
	gtk_container_set_border_width ((GtkContainer*) _tmp6_, (guint) 0);
	_tmp7_ = self->ebox;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp7_);
	_tmp8_ = gvc_mixer_control_new (MIXER_NAME);
	_tmp9_ = _tmp8_;
	sound_indicator_set_mixer (self, _tmp9_);
	_g_object_unref0 (_tmp9_);
	_tmp10_ = self->priv->_mixer;
	g_signal_connect_object (_tmp10_, "state-changed", (GCallback) _sound_indicator_on_state_change_gvc_mixer_control_state_changed, self, 0);
	_tmp11_ = self->priv->_mixer;
	g_signal_connect_object (_tmp11_, "default-sink-changed", (GCallback) _sound_indicator_on_sink_changed_gvc_mixer_control_default_sink_changed, self, 0);
	_tmp12_ = self->priv->_mixer;
	gvc_mixer_control_open (_tmp12_);
	sound_indicator_create_sound_popover (self);
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp13_, "sound-applet");
	_tmp14_ = self->popover;
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
	gtk_style_context_add_class (_tmp15_, "sound-popover");
	_tmp16_ = self->ebox;
	gtk_widget_add_events ((GtkWidget*) _tmp16_, (gint) GDK_SCROLL_MASK);
	_tmp17_ = self->ebox;
	gtk_widget_add_events ((GtkWidget*) _tmp17_, (gint) GDK_BUTTON_RELEASE_MASK);
	_tmp18_ = self->ebox;
	g_signal_connect_object ((GtkWidget*) _tmp18_, "scroll-event", (GCallback) _sound_indicator_on_scroll_event_gtk_widget_scroll_event, self, 0);
	_tmp19_ = self->ebox;
	g_signal_connect_object ((GtkWidget*) _tmp19_, "button-release-event", (GCallback) _sound_indicator_on_button_release_event_gtk_widget_button_release_event, self, 0);
	gtk_widget_show_all ((GtkWidget*) self);
	return self;
}

SoundIndicator*
sound_indicator_new (void)
{
	return sound_indicator_construct (TYPE_SOUND_INDICATOR);
}

static gboolean
sound_indicator_on_button_release_event (SoundIndicator* self,
                                         GdkEventButton* e)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (e != NULL, FALSE);
	if (e->button == ((guint) GDK_BUTTON_MIDDLE)) {
		gboolean is_muted = FALSE;
		GvcMixerStream* _tmp0_;
		GvcMixerStream* _tmp3_;
		_tmp0_ = self->priv->stream;
		is_muted = gvc_mixer_stream_get_volume (_tmp0_) == ((guint32) 0);
		if (is_muted) {
			GvcMixerStream* _tmp1_;
			_tmp1_ = self->priv->stream;
			gvc_mixer_stream_set_volume (_tmp1_, self->unmuted_volume_val);
		} else {
			GvcMixerStream* _tmp2_;
			_tmp2_ = self->priv->stream;
			gvc_mixer_stream_set_volume (_tmp2_, (guint32) 0);
		}
		_tmp3_ = self->priv->stream;
		gvc_mixer_stream_push_volume (_tmp3_);
	} else {
		result = GDK_EVENT_PROPAGATE;
		return result;
	}
	result = GDK_EVENT_STOP;
	return result;
}

/**
     * Create the GtkPopover to display on primary click action, with an adjustable
     * scale
     */
static void
__lambda8_ (SoundIndicator* self)
{
	sound_indicator_adjust_volume_increment (self, -self->priv->step_size);
}

static void
___lambda8__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
	__lambda8_ ((SoundIndicator*) self);
}

static void
_sound_indicator_on_scale_changed_gtk_range_value_changed (GtkRange* _sender,
                                                           gpointer self)
{
	sound_indicator_on_scale_changed ((SoundIndicator*) self);
}

static void
__lambda9_ (SoundIndicator* self)
{
	sound_indicator_adjust_volume_increment (self, +self->priv->step_size);
}

static void
___lambda9__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
	__lambda9_ ((SoundIndicator*) self);
}

static void
_sound_indicator_open_sound_settings_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
	sound_indicator_open_sound_settings ((SoundIndicator*) self);
}

static void
sound_indicator_create_sound_popover (SoundIndicator* self)
{
	GtkEventBox* _tmp0_;
	BudgiePopover* _tmp1_;
	GtkBox* main_box = NULL;
	GtkBox* _tmp2_;
	GtkBox* popover_box = NULL;
	GtkBox* _tmp3_;
	BudgiePopover* _tmp4_;
	GtkButton* sub_button = NULL;
	GtkButton* _tmp5_;
	GtkButton* plus_button = NULL;
	GtkButton* _tmp6_;
	GtkScale* _tmp7_;
	GtkScale* _tmp8_;
	GtkScale* _tmp9_;
	gulong _tmp10_;
	GtkScale* _tmp11_;
	GtkScale* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkStyleContext* _tmp16_;
	GtkScale* _tmp17_;
	GtkScale* _tmp18_;
	GtkSeparator* sep = NULL;
	GtkSeparator* _tmp19_;
	GtkButton* button = NULL;
	GtkButton* _tmp20_;
	GtkWidget* _tmp21_;
	GtkStyleContext* _tmp22_;
	BudgiePopover* _tmp23_;
	GtkWidget* _tmp24_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->ebox;
	_tmp1_ = (BudgiePopover*) budgie_popover_new ((GtkWidget*) _tmp0_);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->popover);
	self->popover = _tmp1_;
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp2_);
	main_box = _tmp2_;
	gtk_container_set_border_width ((GtkContainer*) main_box, (guint) 6);
	_tmp3_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp3_);
	popover_box = _tmp3_;
	gtk_box_pack_start (main_box, (GtkWidget*) popover_box, FALSE, FALSE, (guint) 0);
	_tmp4_ = self->popover;
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) main_box);
	_tmp5_ = (GtkButton*) gtk_button_new_from_icon_name ("list-remove-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp5_);
	sub_button = _tmp5_;
	_tmp6_ = (GtkButton*) gtk_button_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp6_);
	plus_button = _tmp6_;
	gtk_box_pack_start (popover_box, (GtkWidget*) sub_button, FALSE, FALSE, (guint) 1);
	g_signal_connect_object (sub_button, "clicked", (GCallback) ___lambda8__gtk_button_clicked, self, 0);
	_tmp7_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) 0, (gdouble) 100, (gdouble) 1);
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->volume_scale);
	self->priv->volume_scale = _tmp7_;
	_tmp8_ = self->priv->volume_scale;
	gtk_box_pack_start (popover_box, (GtkWidget*) _tmp8_, FALSE, FALSE, (guint) 0);
	_tmp9_ = self->priv->volume_scale;
	_tmp10_ = g_signal_connect_object ((GtkRange*) _tmp9_, "value-changed", (GCallback) _sound_indicator_on_scale_changed_gtk_range_value_changed, self, 0);
	self->priv->scale_id = _tmp10_;
	gtk_box_pack_start (popover_box, (GtkWidget*) plus_button, FALSE, FALSE, (guint) 1);
	g_signal_connect_object (plus_button, "clicked", (GCallback) ___lambda9__gtk_button_clicked, self, 0);
	_tmp11_ = self->priv->volume_scale;
	gtk_scale_set_draw_value (_tmp11_, FALSE);
	_tmp12_ = self->priv->volume_scale;
	gtk_widget_set_size_request ((GtkWidget*) _tmp12_, 140, -1);
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) sub_button);
	gtk_style_context_add_class (_tmp13_, "flat");
	_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) sub_button);
	gtk_style_context_add_class (_tmp14_, "image-button");
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) plus_button);
	gtk_style_context_add_class (_tmp15_, "flat");
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) plus_button);
	gtk_style_context_add_class (_tmp16_, "image-button");
	gtk_widget_set_can_focus ((GtkWidget*) sub_button, FALSE);
	gtk_widget_set_can_focus ((GtkWidget*) plus_button, FALSE);
	_tmp17_ = self->priv->volume_scale;
	gtk_widget_set_can_focus ((GtkWidget*) _tmp17_, FALSE);
	_tmp18_ = self->priv->volume_scale;
	gtk_range_set_inverted ((GtkRange*) _tmp18_, FALSE);
	_tmp19_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp19_);
	sep = _tmp19_;
	gtk_box_pack_start (main_box, (GtkWidget*) sep, FALSE, FALSE, (guint) 1);
	_tmp20_ = (GtkButton*) gtk_button_new_with_label (_ ("Sound settings"));
	g_object_ref_sink (_tmp20_);
	button = _tmp20_;
	_tmp21_ = gtk_bin_get_child ((GtkBin*) button);
	gtk_widget_set_halign (_tmp21_, GTK_ALIGN_START);
	_tmp22_ = gtk_widget_get_style_context ((GtkWidget*) button);
	gtk_style_context_add_class (_tmp22_, GTK_STYLE_CLASS_FLAT);
	g_signal_connect_object (button, "clicked", (GCallback) _sound_indicator_open_sound_settings_gtk_button_clicked, self, 0);
	gtk_box_pack_start (main_box, (GtkWidget*) button, FALSE, FALSE, (guint) 0);
	_tmp23_ = self->popover;
	_tmp24_ = gtk_bin_get_child ((GtkBin*) _tmp23_);
	gtk_widget_show_all (_tmp24_);
	_g_object_unref0 (button);
	_g_object_unref0 (sep);
	_g_object_unref0 (plus_button);
	_g_object_unref0 (sub_button);
	_g_object_unref0 (popover_box);
	_g_object_unref0 (main_box);
}

static void
sound_indicator_on_sink_changed (SoundIndicator* self,
                                 guint id)
{
	g_return_if_fail (self != NULL);
	sound_indicator_set_default_mixer (self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_sound_indicator_on_notify_g_object_notify (GObject* _sender,
                                            GParamSpec* pspec,
                                            gpointer self)
{
	sound_indicator_on_notify ((SoundIndicator*) self, _sender, pspec);
}

static void
sound_indicator_set_default_mixer (SoundIndicator* self)
{
	GvcMixerStream* _tmp0_;
	GvcMixerControl* _tmp2_;
	GvcMixerStream* _tmp3_;
	GvcMixerStream* _tmp4_;
	GvcMixerStream* _tmp5_;
	gulong _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->stream;
	if (_tmp0_ != NULL) {
		GvcMixerStream* _tmp1_;
		_tmp1_ = self->priv->stream;
		g_signal_handler_disconnect (_tmp1_, self->priv->notify_id);
	}
	_tmp2_ = self->priv->_mixer;
	_tmp3_ = gvc_mixer_control_get_default_sink (_tmp2_);
	_tmp4_ = _g_object_ref0 (_tmp3_);
	_g_object_unref0 (self->priv->stream);
	self->priv->stream = _tmp4_;
	_tmp5_ = self->priv->stream;
	_tmp6_ = g_signal_connect_object ((GObject*) _tmp5_, "notify", (GCallback) _sound_indicator_on_notify_g_object_notify, self, 0);
	self->priv->notify_id = _tmp6_;
	sound_indicator_update_volume (self);
}

static void
sound_indicator_on_notify (SoundIndicator* self,
                           GObject* o,
                           GParamSpec* p)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp1_ = p->name;
	if (g_strcmp0 (_tmp1_, "volume") == 0) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp2_;
		_tmp2_ = p->name;
		_tmp0_ = g_strcmp0 (_tmp2_, "is-muted") == 0;
	}
	if (_tmp0_) {
		sound_indicator_update_volume (self);
	}
}

/**
     * Called when something changes on the mixer, i.e. we connected
     * This is where we hook into the stream for changes
     */
void
sound_indicator_on_state_change (SoundIndicator* self,
                                 guint new_state)
{
	g_return_if_fail (self != NULL);
	if (new_state == ((guint) GVC_STATE_READY)) {
		sound_indicator_set_default_mixer (self);
	}
}

/**
     * Update from scroll events. turn volume up + down.
     */
gboolean
sound_indicator_on_scroll_event (SoundIndicator* self,
                                 GdkEventScroll* event)
{
	GvcMixerStream* _tmp0_;
	guint32 vol = 0U;
	GvcMixerStream* _tmp1_;
	guint32 orig_vol = 0U;
	GdkScrollDirection _tmp2_;
	gdouble max_amp = 0.0;
	GvcMixerControl* _tmp3_;
	gdouble norm = 0.0;
	GvcMixerControl* _tmp4_;
	GtkScale* _tmp5_;
	GvcMixerStream* _tmp6_;
	GtkScale* _tmp8_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->stream;
	g_return_val_if_fail (_tmp0_ != NULL, FALSE);
	_tmp1_ = self->priv->stream;
	vol = gvc_mixer_stream_get_volume (_tmp1_);
	orig_vol = vol;
	_tmp2_ = event->direction;
	switch (_tmp2_) {
		case GDK_SCROLL_UP:
		{
			vol += (guint32) self->priv->step_size;
			break;
		}
		case GDK_SCROLL_DOWN:
		{
			vol -= (guint32) self->priv->step_size;
			if (vol > orig_vol) {
				vol = (guint32) 0;
			}
			break;
		}
		default:
		{
			result = FALSE;
			return result;
		}
	}
	_tmp3_ = self->priv->_mixer;
	max_amp = gvc_mixer_control_get_vol_max_amplified (_tmp3_);
	_tmp4_ = self->priv->_mixer;
	norm = gvc_mixer_control_get_vol_max_norm (_tmp4_);
	if (max_amp < norm) {
		max_amp = norm;
	}
	if (((gdouble) vol) > max_amp) {
		vol = (guint32) max_amp;
	}
	if (((gdouble) vol) >= norm) {
		vol = (guint32) norm;
	}
	_tmp5_ = self->priv->volume_scale;
	g_signal_handler_block (_tmp5_, self->priv->scale_id);
	_tmp6_ = self->priv->stream;
	if (gvc_mixer_stream_set_volume (_tmp6_, vol)) {
		GvcMixerStream* _tmp7_;
		_tmp7_ = self->priv->stream;
		gvc_mixer_stream_push_volume (_tmp7_);
	}
	_tmp8_ = self->priv->volume_scale;
	g_signal_handler_unblock (_tmp8_, self->priv->scale_id);
	result = TRUE;
	return result;
}

/**
     * Update our icon when something changed (volume/mute)
     */
void
sound_indicator_update_volume (SoundIndicator* self)
{
	gdouble vol_norm = 0.0;
	GvcMixerControl* _tmp0_;
	guint32 vol = 0U;
	GvcMixerStream* _tmp1_;
	gint n = 0;
	gchar* image_name = NULL;
	gboolean _tmp2_ = FALSE;
	GvcMixerStream* _tmp3_;
	GtkImage* _tmp8_;
	const gchar* _tmp9_;
	gdouble vol_max = 0.0;
	GvcMixerControl* _tmp10_;
	gfloat pct = 0.0F;
	guint ipct = 0U;
	GtkImage* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GtkScale* _tmp16_;
	GtkScale* _tmp17_;
	GtkScale* _tmp20_;
	GtkAdjustment* _tmp21_;
	GtkScale* _tmp22_;
	GvcMixerStream* _tmp23_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_mixer;
	vol_norm = gvc_mixer_control_get_vol_max_norm (_tmp0_);
	_tmp1_ = self->priv->stream;
	vol = gvc_mixer_stream_get_volume (_tmp1_);
	n = ((gint) floor ((3 * vol) / vol_norm)) + 1;
	_tmp3_ = self->priv->stream;
	if (gvc_mixer_stream_get_is_muted (_tmp3_)) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = vol <= ((guint32) 0);
	}
	if (_tmp2_) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup ("audio-volume-muted-symbolic");
		_g_free0 (image_name);
		image_name = _tmp4_;
	} else {
		switch (n) {
			case 1:
			{
				gchar* _tmp5_;
				_tmp5_ = g_strdup ("audio-volume-low-symbolic");
				_g_free0 (image_name);
				image_name = _tmp5_;
				break;
			}
			case 2:
			{
				gchar* _tmp6_;
				_tmp6_ = g_strdup ("audio-volume-medium-symbolic");
				_g_free0 (image_name);
				image_name = _tmp6_;
				break;
			}
			default:
			{
				gchar* _tmp7_;
				_tmp7_ = g_strdup ("audio-volume-high-symbolic");
				_g_free0 (image_name);
				image_name = _tmp7_;
				break;
			}
		}
	}
	_tmp8_ = self->priv->_widget;
	_tmp9_ = image_name;
	gtk_image_set_from_icon_name (_tmp8_, _tmp9_, (GtkIconSize) GTK_ICON_SIZE_MENU);
	_tmp10_ = self->priv->_mixer;
	vol_max = gvc_mixer_control_get_vol_max_amplified (_tmp10_);
	self->priv->step_size = vol_max / 20;
	pct = (((gfloat) vol) / ((gfloat) vol_norm)) * 100;
	ipct = (guint) pct;
	_tmp11_ = self->priv->_widget;
	_tmp12_ = g_strdup_printf ("%u", ipct);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_strconcat (_tmp13_, "%", NULL);
	_tmp15_ = _tmp14_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp11_, _tmp15_);
	_g_free0 (_tmp15_);
	_g_free0 (_tmp13_);
	_tmp16_ = self->priv->volume_scale;
	g_signal_handler_block (_tmp16_, self->priv->scale_id);
	_tmp17_ = self->priv->volume_scale;
	gtk_range_set_range ((GtkRange*) _tmp17_, (gdouble) 0, vol_norm);
	if (((gdouble) vol) > vol_norm) {
		GtkScale* _tmp18_;
		_tmp18_ = self->priv->volume_scale;
		gtk_range_set_value ((GtkRange*) _tmp18_, (gdouble) vol);
	} else {
		GtkScale* _tmp19_;
		_tmp19_ = self->priv->volume_scale;
		gtk_range_set_value ((GtkRange*) _tmp19_, (gdouble) vol);
	}
	_tmp20_ = self->priv->volume_scale;
	_tmp21_ = gtk_range_get_adjustment ((GtkRange*) _tmp20_);
	gtk_adjustment_set_page_increment (_tmp21_, self->priv->step_size);
	_tmp22_ = self->priv->volume_scale;
	g_signal_handler_unblock (_tmp22_, self->priv->scale_id);
	gtk_widget_show_all ((GtkWidget*) self);
	gtk_widget_queue_draw ((GtkWidget*) self);
	_tmp23_ = self->priv->stream;
	if (gvc_mixer_stream_get_volume (_tmp23_) != ((guint32) 0)) {
		GvcMixerStream* _tmp24_;
		_tmp24_ = self->priv->stream;
		self->unmuted_volume_val = gvc_mixer_stream_get_volume (_tmp24_);
	}
	_g_free0 (image_name);
}

/**
     * The scale changed value - update the stream volume to match
     */
static void
sound_indicator_on_scale_changed (SoundIndicator* self)
{
	gboolean _tmp0_ = FALSE;
	GvcMixerStream* _tmp1_;
	gdouble scale_value = 0.0;
	GtkScale* _tmp3_;
	GtkScale* _tmp4_;
	GvcMixerStream* _tmp5_;
	GtkScale* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->stream;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		GvcMixerControl* _tmp2_;
		_tmp2_ = self->priv->_mixer;
		_tmp0_ = _tmp2_ == NULL;
	}
	if (_tmp0_) {
		return;
	}
	_tmp3_ = self->priv->volume_scale;
	scale_value = gtk_range_get_value ((GtkRange*) _tmp3_);
	_tmp4_ = self->priv->volume_scale;
	g_signal_handler_block (_tmp4_, self->priv->scale_id);
	_tmp5_ = self->priv->stream;
	if (gvc_mixer_stream_set_volume (_tmp5_, (guint32) scale_value)) {
		GvcMixerStream* _tmp6_;
		_tmp6_ = self->priv->stream;
		gvc_mixer_stream_push_volume (_tmp6_);
	}
	_tmp7_ = self->priv->volume_scale;
	g_signal_handler_unblock (_tmp7_, self->priv->scale_id);
}

/**
     * Adjust the volume by a given +/- increment and bounds limit it
     */
static void
sound_indicator_adjust_volume_increment (SoundIndicator* self,
                                         gdouble increment)
{
	gboolean _tmp0_ = FALSE;
	GvcMixerStream* _tmp1_;
	gint32 vol = 0;
	GvcMixerStream* _tmp3_;
	gdouble max_norm = 0.0;
	GvcMixerControl* _tmp4_;
	GtkScale* _tmp5_;
	GvcMixerStream* _tmp6_;
	GtkScale* _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->stream;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		GvcMixerControl* _tmp2_;
		_tmp2_ = self->priv->_mixer;
		_tmp0_ = _tmp2_ == NULL;
	}
	if (_tmp0_) {
		return;
	}
	_tmp3_ = self->priv->stream;
	vol = (gint32) gvc_mixer_stream_get_volume (_tmp3_);
	_tmp4_ = self->priv->_mixer;
	max_norm = gvc_mixer_control_get_vol_max_norm (_tmp4_);
	vol += (gint32) increment;
	if (vol < ((gint32) 0)) {
		vol = (gint32) 0;
	} else {
		if (((gdouble) vol) > max_norm) {
			vol = (gint32) max_norm;
		}
	}
	_tmp5_ = self->priv->volume_scale;
	g_signal_handler_block (_tmp5_, self->priv->scale_id);
	_tmp6_ = self->priv->stream;
	if (gvc_mixer_stream_set_volume (_tmp6_, (guint32) vol)) {
		GvcMixerStream* _tmp7_;
		_tmp7_ = self->priv->stream;
		gvc_mixer_stream_push_volume (_tmp7_);
	}
	_tmp8_ = self->priv->volume_scale;
	g_signal_handler_unblock (_tmp8_, self->priv->scale_id);
}

static void
sound_indicator_open_sound_settings (SoundIndicator* self)
{
	BudgiePopover* _tmp0_;
	GDesktopAppInfo* app_info = NULL;
	GDesktopAppInfo* _tmp1_;
	GDesktopAppInfo* _tmp2_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->popover;
	gtk_widget_hide ((GtkWidget*) _tmp0_);
	_tmp1_ = g_desktop_app_info_new ("gnome-sound-panel.desktop");
	app_info = _tmp1_;
	_tmp2_ = app_info;
	if (_tmp2_ == NULL) {
		_g_object_unref0 (app_info);
		return;
	}
	{
		GDesktopAppInfo* _tmp3_;
		_tmp3_ = app_info;
		g_app_info_launch ((GAppInfo*) _tmp3_, NULL, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_message ("SoundIndicator.vala:356: Unable to launch gnome-sound-panel.desktop: %" \
"s", _tmp5_);
		_g_error_free0 (e);
	}
	__finally2:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (app_info);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_object_unref0 (app_info);
}

GtkImage*
sound_indicator_get_widget (SoundIndicator* self)
{
	GtkImage* result;
	GtkImage* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_widget;
	result = _tmp0_;
	return result;
}

void
sound_indicator_set_widget (SoundIndicator* self,
                            GtkImage* value)
{
	g_return_if_fail (self != NULL);
	if (sound_indicator_get_widget (self) != value) {
		GtkImage* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_widget);
		self->priv->_widget = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, sound_indicator_properties[SOUND_INDICATOR_WIDGET_PROPERTY]);
	}
}

GvcMixerControl*
sound_indicator_get_mixer (SoundIndicator* self)
{
	GvcMixerControl* result;
	GvcMixerControl* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_mixer;
	result = _tmp0_;
	return result;
}

void
sound_indicator_set_mixer (SoundIndicator* self,
                           GvcMixerControl* value)
{
	g_return_if_fail (self != NULL);
	if (sound_indicator_get_mixer (self) != value) {
		GvcMixerControl* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_mixer);
		self->priv->_mixer = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, sound_indicator_properties[SOUND_INDICATOR_MIXER_PROPERTY]);
	}
}

static void
sound_indicator_class_init (SoundIndicatorClass * klass,
                            gpointer klass_data)
{
	sound_indicator_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SoundIndicator_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_indicator_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_indicator_set_property;
	G_OBJECT_CLASS (klass)->finalize = sound_indicator_finalize;
	/** Current image to display */
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_INDICATOR_WIDGET_PROPERTY, sound_indicator_properties[SOUND_INDICATOR_WIDGET_PROPERTY] = g_param_spec_object ("widget", "widget", "widget", gtk_image_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/** Our mixer */
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_INDICATOR_MIXER_PROPERTY, sound_indicator_properties[SOUND_INDICATOR_MIXER_PROPERTY] = g_param_spec_object ("mixer", "mixer", "mixer", gvc_mixer_control_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
sound_indicator_instance_init (SoundIndicator * self,
                               gpointer klass)
{
	self->priv = sound_indicator_get_instance_private (self);
	self->unmuted_volume_val = (guint32) 0;
}

static void
sound_indicator_finalize (GObject * obj)
{
	SoundIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SOUND_INDICATOR, SoundIndicator);
	_g_object_unref0 (self->priv->_widget);
	_g_object_unref0 (self->priv->_mixer);
	_g_object_unref0 (self->priv->stream);
	_g_object_unref0 (self->ebox);
	_g_object_unref0 (self->popover);
	_g_object_unref0 (self->priv->volume_scale);
	G_OBJECT_CLASS (sound_indicator_parent_class)->finalize (obj);
}

GType
sound_indicator_get_type (void)
{
	return sound_indicator_type_id;
}

GType
sound_indicator_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundIndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundIndicator), 0, (GInstanceInitFunc) sound_indicator_instance_init, NULL };
	sound_indicator_type_id = g_type_module_register_type (module, gtk_bin_get_type (), "SoundIndicator", &g_define_type_info, 0);
	SoundIndicator_private_offset = sizeof (SoundIndicatorPrivate);
	return sound_indicator_type_id;
}

static void
_vala_sound_indicator_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	SoundIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SOUND_INDICATOR, SoundIndicator);
	switch (property_id) {
		case SOUND_INDICATOR_WIDGET_PROPERTY:
		g_value_set_object (value, sound_indicator_get_widget (self));
		break;
		case SOUND_INDICATOR_MIXER_PROPERTY:
		g_value_set_object (value, sound_indicator_get_mixer (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_sound_indicator_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	SoundIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SOUND_INDICATOR, SoundIndicator);
	switch (property_id) {
		case SOUND_INDICATOR_WIDGET_PROPERTY:
		sound_indicator_set_widget (self, g_value_get_object (value));
		break;
		case SOUND_INDICATOR_MIXER_PROPERTY:
		sound_indicator_set_mixer (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

